$(document).ready(function($) {
	$('#accordion').find('.accordion-toggle').click(function(){
	  $(this).next().slideToggle(50);
	});
	
	var constFalse = constFunc(false);

	// add onclick handler for all tabElements
	var tabs = document.getElementsByClassName("tabElement");
	for (var i = 0; i < tabs.length; ++i) {
		var tab = tabs[i];
		tab.onclick = showCurrentTab;

		// prevent child anchors from modifying page's url
		var anchors = tab.getElementsByTagName("a");
		for (var j = 0; j < anchors.length; ++j) {
			anchors.onclick = constFalse;
		}
	}
	
	$('.api-toggle').click(function(e) {
		//Handle the +/- button image clicks
		var divId = e.target.id.substring(0, e.target.id.length - '_link'.length + 1);
		
		document.getElementById(divId).style.display = (document.getElementById(divId).style.display == 'none') ? 'block' : 'none';	
	
		var imageElement = document.getElementById(divId + "_img");	
		imageElement.src = (imageElement.src.indexOf('plus.gif') >= 0) ? imageElement.src.replace('plus.gif', 'minus.gif') : imageElement.src.replace('minus.gif', 'plus.gif');
	
		e.preventDefault();
	});
  });
  
  
  

/* This function brings the current tab and content in front */
function showCurrentTab(e) {
	var currTab = this;
	var tabGroup = this.parentNode;
	var tabs = tabGroup.getElementsByClassName("tabElement");
	
	for (var i = 0; i < tabs.length; ++i) {
		removeClassName(tabs[i], "currentTab");
	}

	addClassName(currTab, "currentTab")
	
	// Get the associated tabContent group so that we can find
	// code sample referred to by the href
	var divGroup = tabGroup.parentNode;
	var contents = divGroup.getElementsByClassName("tabContent");
	var anchor = currTab.getElementsByTagName("a")[0];
	var snippetType = getHash(anchor.href);
	showCurrentTabContent(contents, snippetType);

	return false; // prevent anchor events as well
}

/* show the associated code sample in the tab content list and hides the other code sample*/
function showCurrentTabContent(contents, snippetType) {
	if (contents.length === 0) {
		return;
	}
	var samples = contents[0].getElementsByClassName("codeSample");

	for (var i = 0; i < samples.length; ++i) {
		var sample = samples[i];
		if (hasClassName(sample, snippetType)) {
			removeClassName(sample, "hide");
		}
		else {
			addClassName(sample, "hide");
		}
	}
}


function constFunc(x) {
	return function () {
		return x;
	}
}

function getHash(url) {
	return url.substring(url.lastIndexOf("#") + 1);
}

function trim(str) {
	return str.replace(/^\s+/, "").replace(/\s+$/, "");
}

function condenseWs(str) {
	return str.replace(/\s+/g, " ");
}

function hasClassName(elt, className) {
	var pat = new RegExp("\\b" + className + "\\b");
	return pat.test(elt.className);
}

function addClassName(elt, className) {
	if (!hasClassName(elt, className)) {
		elt.className += " " + className;
	}
}

function removeClassName(elt, className) {
	var pat = new RegExp("\\b" + className + "\\b", "g");
	elt.className = trim(condenseWs(elt.className.replace(pat, "")));
}


function constFunc(x) {
	return function () {
		return x;
	}
}

function getHash(url) {
	return url.substring(url.lastIndexOf("#") + 1);
}

function trim(str) {
	return str.replace(/^\s+/, "").replace(/\s+$/, "");
}

function condenseWs(str) {
	return str.replace(/\s+/g, " ");
}

function hasClassName(elt, className) {
	var pat = new RegExp("\\b" + className + "\\b");
	return pat.test(elt.className);
}

function addClassName(elt, className) {
	if (!hasClassName(elt, className)) {
		elt.className += " " + className;
	}
}

function removeClassName(elt, className) {
	var pat = new RegExp("\\b" + className + "\\b", "g");
	elt.className = trim(condenseWs(elt.className.replace(pat, "")));
}

function toggleVisibility(linkObj)
{
 var base = $(linkObj).attr('id');
 var summary = $('#'+base+'-summary');
 var content = $('#'+base+'-content');
 var trigger = $('#'+base+'-trigger');
 var src=$(trigger).attr('src');
 if (content.is(':visible')===true) {
   content.hide();
   summary.show();
   $(linkObj).addClass('closed').removeClass('opened');
   $(trigger).attr('src',src.substring(0,src.length-8)+'closed.png');
 } else {
   content.show();
   summary.hide();
   $(linkObj).removeClass('closed').addClass('opened');
   $(trigger).attr('src',src.substring(0,src.length-10)+'open.png');
 } 
 return false;
}

function updateStripes()
{
  $('table.directory tr').
       removeClass('even').filter(':visible:even').addClass('even');
}

function toggleLevel(level)
{
  $('table.directory tr').each(function() {
    var l = this.id.split('_').length-1;
    var i = $('#img'+this.id.substring(3));
    var a = $('#arr'+this.id.substring(3));
    if (l<level+1) {
      i.removeClass('iconfopen iconfclosed').addClass('iconfopen');
      a.html('&#9660;');
      $(this).show();
    } else if (l==level+1) {
      i.removeClass('iconfclosed iconfopen').addClass('iconfclosed');
      a.html('&#9658;');
      $(this).show();
    } else {
      $(this).hide();
    }
  });
  updateStripes();
}

function toggleFolder(id)
{
  // the clicked row
  var currentRow = $('#row_'+id);

  // all rows after the clicked row
  var rows = currentRow.nextAll("tr");

  var re = new RegExp('^row_'+id+'\\d+_$', "i"); //only one sub

  // only match elements AFTER this one (can't hide elements before)
  var childRows = rows.filter(function() { return this.id.match(re); });

  // first row is visible we are HIDING
  if (childRows.filter(':first').is(':visible')===true) {
    // replace down arrow by right arrow for current row
    var currentRowSpans = currentRow.find("span");
    currentRowSpans.filter(".iconfopen").removeClass("iconfopen").addClass("iconfclosed");
    currentRowSpans.filter(".arrow").html('&#9658;');
    rows.filter("[id^=row_"+id+"]").hide(); // hide all children
  } else { // we are SHOWING
    // replace right arrow by down arrow for current row
    var currentRowSpans = currentRow.find("span");
    currentRowSpans.filter(".iconfclosed").removeClass("iconfclosed").addClass("iconfopen");
    currentRowSpans.filter(".arrow").html('&#9660;');
    // replace down arrows by right arrows for child rows
    var childRowsSpans = childRows.find("span");
    childRowsSpans.filter(".iconfopen").removeClass("iconfopen").addClass("iconfclosed");
    childRowsSpans.filter(".arrow").html('&#9658;');
    childRows.show(); //show all children
  }
  updateStripes();
}


function toggleInherit(id)
{
  var rows = $('tr.inherit.'+id);
  var img = $('tr.inherit_header.'+id+' img');
  var src = $(img).attr('src');
  if (rows.filter(':first').is(':visible')===true) {
    rows.css('display','none');
    $(img).attr('src',src.substring(0,src.length-8)+'closed.png');
  } else {
    rows.css('display','table-row'); // using show() causes jump in firefox
    $(img).attr('src',src.substring(0,src.length-10)+'open.png');
  }
}

